
# STAR_COST: a software for optimisation of loop-breaking in pedigrees
# use "cost.pl --help"  for details
#-------------------------- help message begins -----------------


$help_message="

CONTROL LINE:
cost.pl input_pedigree_file input_list_file

where: 

1. Input_pedigree_file may be named arbitrary. The file must contain columns 
with pedigree ID (ped), personal ID (id), father's ID (fa), mother's ID (mo), 
sex, and original ID (orig_id) defined for every person. The file must have a 
header line, which should contain abovementioned keywords. There may be more 
columns in the input file, these are just ignored. This is a typical output 
from our pedigree verification and recoding programm, RECODE_PED. In this file,
ids are coded as integers from 1 to total number of people in the sample. The 
parents come before offspring. The sexes are coded as '1' for male and '2' for 
female. orig_id contains original person name or id. It is a text value. 
Separator may be defined as comma or tab or space. 
2. Input_list_file may be named arbitrary. The file consists of a column with 
IDs of persons with known phenotype or genotype. The file has not a header line.

OUTPUT FILES: w_0.dat, w_s.dat, w_l.dat for different cost functions. Every 
file has three columns: odered IDs of breaker and his/her spouse and cost 
function. Additional file w_res.dat contains 5 columns: odered IDs and three 
cost functions.

SEE readme_cost.doc for details.


";
#-------------------------- help message ends -----------------

#***** get command line arguments (names of file pedigree and list) *****

die "run cost.pl --help for details\n" if (@ARGV<1);

if ($ARGV[0] eq "--help") {
	print "${help_message}";
#shoud be replaced with soft end!
	die ""; 
}; 


if (@ARGV==2)   {
		$inped=$ARGV[0] ;
		$inlist=$ARGV[1];
 }
else	{die "ERROR of comand line\n";
 }

unlink 'task_w.inp'; ## delete task file 

open (OTASK,">task_w.inp");

print (OTASK "$inped\n$inlist\n");

close OTASK;
	
print "EDGEs FORMATION\n";
($sec,$min,$hour,$mday,$mon,$year)=localtime;
print "${hour}:${min}:${sec}\n";
system("edge.exe");
print "CALCULATION OF COST FOR DIFFERENT EDGES\n";
($sec,$min,$hour,$mday,$mon,$year)=localtime;
print "${hour}:${min}:${sec}\n";
print "WAITING\n";
system("relat.exe");
print "FINAL STEP OF PROGRAM\n";
($sec,$min,$hour,$mday,$mon,$year)=localtime;
print "${hour}:${min}:${sec}\n";
system("cost.exe");
($sec,$min,$hour,$mday,$mon,$year)=localtime;
print "${hour}:${min}:${sec}\n";

#unlink 'edge.dat','task_w.inp';
#unlink 'rrr.dat','ped_ped.dat','task_w_fin.inp'; ## delete files 

