
      program loop_my
C	Loops cutting according to my algorithm (duplication
C	of star person in one of the multiple marriages)
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	Character*20 name_ped, weight_marr

	character*80 ccc
	include 'par.incl'
	include 'mas.incl'
	dimension luk(N_SIZE),kpar(N_SIZE)
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C	INPUT FILES: mas,istar,weight
C	STEP 0: reading of input files, testing of massive sizes
C		(N_SIZE, N_STAR)
C		ordering of istar and weight massives on decreasing 
C			of weight (program ORDER) 
C	STEP 1: trimming of pedigrees and NP-massive formation
C		For every pedigree pair structure is defined (IPAIR
C		massiv) and all unlooped pairs are eliminated. IDs of 
C		parents from connected pairs are rewritten in massive
C		IPAR defined for full sample. For every star the 
C		number of IPAR line of istar(i,1) parents is written 
C		in massive N_FROM(i),i=1,nstar. 
C	STEP 2: connecting of NPs via odered stars and loop testing 
C		Initial value of massive NUM_PAR for every pair is 
C		the number of this pair line in massive IPAR. Pairs
C		connection is realized via renumeration of one of them.
C		For loop testing number of connected structures are 
C		calculated.  
C	Step 4: selection of unconnected stars = loop breakers 

C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C	STEP 0: reading of input files, testing of massive sizes
C		(N_SIZE, N_STAR)
C		ordering of istar and weight massives on decreasing 
C			of weight (program ORDER) 
C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                           
 	print*,'READING of initial data'

C	READING of NAMES of initial data  files
C	There are two files of initial data: pedigree data (integer:PED,ID,FA,MO,
C     		SEX;character:KOD) and weight of marriages (integer:ID1, ID2; real:WEIGHT)
	open (unit=1, file='task.inp')
	read (1,*)name_ped
	read (1,*)weight_marr 
	close (unit=1)

C	READING of pedigree data (mas and kod)
	open (unit=1,file=name_ped)
	read (1,*) ccc
	i=0
311	i=i+1
	read (1,*,end=312)(mas(i,j),j=1,5),kod(i)  
	if (mas(i,2).ne.i)then
	Print *,'Incorrect format of input data file on line',i
	pause
	stop
	end if
	ndat=i !!!sample size
	go to 311
312	close (unit=1)
c        print *,'END of reading'

C	Test of declared sample size
	if (ndat.gt.N_SIZE)then
	print *,'ndat>N_SIZE:',ndat,N_SIZE
	stop
	end if

C	READING of weight data 
	open (unit=1,file=weight_marr)
	nstar=0
	i=0
411	i=i+1
	read (1,*,end=412)(istar(i,j),j=1,2),weight(i)  
	nstar=i !!!number of potential breakers
	go to 411
412	close (unit=1)
	if (nstar.eq.0)then
	print *,'Pedigrees have no loops'
	pause
	stop
	end if

C	ORDERING of PERSONS (odered set of IDs in istar(i,j))
	print *,'ORDERING of STAR PERSONS'
	call ORDER    	
cd	do i=1,nstar
cdd	print *,(istar(i,j),j=1,2),weight(i)  
cd	end do
cd	pause 

C	Massiv INS (cumulative sizes of families)

	do i=1,N_FAM
	ins(i)=0
	end do
 
	do 666 i=1,ndat
	ins(mas(i,1)+2)=ins(mas(i,1)+2)+1
666	continue

	n=0
	i=0
667	i=i+1
        n=n+ins(i+2)
	ins(i+2)=ins(i+1)+ins(i+2)
	if (n.lt.ndat)goto 667

	ins(1)=i
c	print *,'INS:',(ins(kk),kk=1,i+2)
c	pause

C	Test of declared number of families
	if (i+1.gt.N_FAM)then
	print *,'nfam>N_FAM:',i,N_FAM
	stop
	end if
C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C	STEP 1: trimming of pedigrees and NP-massive formation
C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	open (unit=3, file='res.dat') !!! OUTPUT FILE - set of breakers
C	PEDIGREE CYCLE
c	Program works with full sample but not each pedigree separately

	np=0 !joint number of pairs

	do i=1,nstar
	n_from(i)=0
	end do

	do 1001 is=1,ins(1)
cd	print *, 'PEDIGREE: ',is
	ls0=ins(is+1)
	ls1=ls0+1
	ls2=ins(is+2)
	lss=ls2-ls0


C	STRUCTURE OF DATA: ipair(i,j), npar, nspou(i)
	CALL structure(is)


C	SOWING of unlooped parts of pedigree: new massiv ipair(i,j),npar
	ip=npar ! initial number of pairs

	call SOW_TREE(is)

c	CONSTRUCTION OF NEW MASSIVES for full sample: ipar(i,3),n_from(i)
	do i=1,npar
cd	print *,(ipair(i,j),j=1,5)
	ipar(i+np,1)=i+np
	ipar(i+np,2)=ipair(i,1)
	ipar(i+np,3)=ipair(i,2)
	end do
cd	pause
cd	print *,'istar:'
	do i=1,nstar
	ist=istar(i,1)
	do j=1,npar
	k=ipair(j,3)
	do jj=1,k
	if(ipair(j,jj+3).eq.ist)then
	n_from(i)=j+np
cd	print *,istar(i,1),istar(i,2),n_from(i)
	goto 111
	end if
	end do
	end do
111	end do
	np=np+npar
cd	do i=1,nstar
cd	print *,istar(i,1),istar(i,2),n_from(i)
cd	end do
cd	pause
1001	continue
	npar=np
	
cd	pause

c	Additional NPR for multimarried persons without parents
cd	print *,'Additional NPs'
	do i=1,nstar
	if (n_from(i).ne.0) goto 112
	ist=istar(i,1)
	npar=npar+1
	n_from(i)=npar
	ipar(npar,1)=npar
	do j=1,nstar
	if (n_from(j).eq.0) then
	if (istar(j,1).eq.ist)n_from(j)=npar
	end if
	end do
cd	print *,npar,istar(i,1),istar(i,2)
112	end do
cd	pause

c	print *,'Common number of pair(+additional NP)=',npar

C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C	STEP 2: connecting of NPs via odered stars and loop testing 
C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	do i=1,nstar
	luk(i)=0
	end do

	jstep=1
	call connect (1,n_con)
	luk(1)=1
cd	print *,'step=',jstep
cd	do i=1,np
cd	print *,i,(ipar(i,j),j=1,3)
cd	end do
cd	pause

	do 304 ii=2,nstar
	
	do i=1,np
	kpar(i)=ipar(i,1) ! zapomnili numeratsiju svjaznih structur
	end do

	call connect (ii,n_con)

	if (n_con.gt.npar-jstep-1)goto 305
	jstep=jstep+1
	luk(ii)=1 ! esli skleili NPs, sohranili novuju numeratsiju structur
	goto 304
305	do i=1,np
	ipar(i,1)=kpar(i)! esli skleivanie zaprescheno, vosstanavlivaem 
c     	numeratsiju svjaznih struktur
	end do
304	continue	

C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C	Step 4: selection of unconnected stars = loop breakers 
C	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	do i=1,nstar
	if(luk(i).eq.0)write(3,*)(istar(i,j),j=1,2)
	end do
	close (unit=3)
	stop
	end


	subroutine connect(ii,n_con)
c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	include 'par.incl'
	include 'mas.incl'
	
	i1=istar(ii,1)
	i2=istar(ii,2)
	isex=mas(i1,5)
	do i=1,npar
	if (ipar(i,isex+1).eq.i1.and.ipar(i,4-isex).eq.i2)goto 10
	end do
	print *,'Incorrect star formation:',i1,i2,isex
	pause
	stop

10	ip=i
	ist=ipar(ip,1) ! number of star's connected structure
	jst=ipar(n_from(ii),1) ! number of star parents connected structure

	n_con=0
	do i=1,npar
	if (ipar(i,1).eq.ist)ipar(i,1)=jst
	if (ipar(i,1).eq.i)n_con=n_con+1
	end do
	
	return
	end

	subroutine SOW_TREE(is)
C	**************************************************
C	SOWING of tree-structures (NP with one connected person and 
C	some unmarried offspring)
c	RESULT: Number of NP and size of mas are decreased
	include 'par.incl'
	include 'mas.incl'
	dimension luk(N_SIZE),mm(M_PAIR)


	ls0=ins(is+1)	                        	
	ls1=ls0+1
	ls2=ins(is+2)
	lss=ls2-ls0

	do i=1,npar
	luk(i)=0
	end do
	nn00=npar

111	kk=0
	do 14 ip=1,npar

	if (luk(ip).eq.1)goto 14
	k_mar=0     ! number of married offspring in IP
	k_sum=0     ! number of offspring in IP
	do i=1,M_PAIR
	mm(i)=0
	end do

C	For every nuclear pedigree (NP) number of offspring (k_sum) and
C	number of married ones (k_mar) are summerized
C	If k_sum=1 and both parents are single married ancestors, they are eliminated
C	If there are married and unmarried offspring in the NP, all unmarried 
C		offspring are eliminated
C	If all offspring are unmarried, all without one of them are eliminated
	k=0
	do 12 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 12
	mmm=mas(i,2)
	k_sum=k_sum+1
	k=k+1
	if (nspou(mmm).ne.0)then
	k_mar=k_mar+1
	mm(k)=1
	end if
12	continue
c        print *,ip,ipair(ip,1),ipair(i,2),k_sum,k_mar
	ih=0

	if (k_mar.eq.0)goto 24 ! all offspring are unmarried
	if(k_mar.eq.k_sum)goto 324 !all offspring are married

C	There are married and unmarried offspring in the NP
	ll=0
	do 19 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 19
	ll=ll+1
	if (mm(ll).eq.0)then
c	print *,'obrezka visjachih 1: IP=',ip,mas(i,2)
	mas(i,1)=0 ! obrezka visjachih
	kk=kk+1
	ih=1
	end if
19	continue

	goto 524

C	all offspring are unmarried
C	ostavljaem odnogo potomka

24	l=0
	do 145 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 145
	if (l.eq.0)then
	l=l+1
	goto 145
	else
c	print *,'obrezka visjachih 2: IP=',ip,mas(i,2)
	mas(i,1)=0
	kk=kk+1
	ih=1
	end if
145	continue

c	correction of massive ipair
524     if (ih.eq.0)goto 324
	l=0
	do 545 i=ls1,ls2
	if (mas(i,1).ne.ip) goto 545
	l=l+1
	ipair(ip,l+3)=mas(i,2)
545	continue
	ipair(ip,3)=l
	k_sum=l
c	print *,'CORR:', ip,(ipair(ip,i),i=1,l+3)

324		if (k_sum.ne.1)goto 14
	m0=ipair(ip,4) ! ID of a single offspring
	m1=ipair(ip,1)
	m2=ipair(ip,2)
	mp1=mas(m1,3)+nspou(m1)-1
	mp2=mas(m2,3)+nspou(m2)-1
	if (mp1.ne.0.and.mp2.ne.0) goto 14
	if (mp1.eq.0.and.mp2.eq.0)then
	
C	both parents are single married ancestors
	mas(m1,1)=0
	mas(m2,1)=0
	nspou(m1)=nspou(m1)-1
	nspou(m2)=nspou(m2)-1
	goto 15
	end if
	
C	one parent is single married ancestor	
	if (nspou(m0).ne.0)goto 14
	if (mp1.ne.0) goto 811
	mas(m1,1)=0
	mp1=0
	nspou(m2)=nspou(m2)-1

	goto 15
811	mas(m2,1)=0
	nspou(m1)=nspou(m1)-1
	goto 15

c	pair elimination
15	luk(ip)=1
	do i1=ls1,ls2
	if(mas(i1,1).eq.ip)then
	mas(i1,1)=0
	mas(i1,3)=0
	mas(i1,4)=0
	end if
	end do
	kk=kk+1
14	continue
	if (kk.ne.0)goto 111
c	pause
C	NEW massiv ipair
	ip=0
888	ip=ip+1
	k=0
	do 814 i=ls1,ls2
	if (mas(i,1).eq.0)goto 814
	if (k.ne.0) goto 815
	ipair(ip,1)=mas(i,3)
	ipair(ip,2)=mas(i,4)
	ipair(ip,3)=1
	ipair(ip,4)=mas(i,2)
	np=mas(i,1)
	mas(i,1)=0
	k=1
	goto 814
815	if (mas(i,1).ne.np)goto 814
	ipair(ip,3)=ipair(ip,3)+1
	ipair(ip,ipair(ip,3)+3)=mas(i,2)
	mas(i,1)=0
814	continue
	if (k.gt.0) goto 888

	npar=ip-1  ! FINAL NUMBER OF NP
	if (nn00.gt.0)print *,'after leaves reduction=', npar
	return
	end


	subroutine ORDER
C	*****************************************
c	STARs ORDERING
	include 'par.incl'
	include 'mas.incl'
c	>>>>>>>>>>>>>>>>>>>
	if (nstar.eq.1)return 
100	k=0
	do 10 i=2,nstar
	if(weight(i).le.weight(i-1))goto 10
	i1=istar(i,1)
	i2=istar(i,2)
	w=weight(i)
	istar(i,1)=istar(i-1,1)
	istar(i,2)=istar(i-1,2)
	weight(i)=weight(i-1)
	istar(i-1,1)=i1
	istar(i-1,2)=i2
	weight(i-1)=w
	k=k+1
10	continue
	if (k.ne.0)goto 100
	return
	end
	

	subroutine STRUCTURE(is)
C	*****************************************
C	STRUCTURE OF DATA:
c	print*,'STRUCTURE OF DATA'
	include 'par.incl'
	include 'mas.incl'

	ls0=ins(is+1)
	ls1=ls0+1
	ls2=ins(is+2)
	lss=ls2-ls0
c	print *,'LS1, LS2',ls1,ls2


C	SET of COUPLES
c		ipair(massiv of pairs)
c		ipair(i,1)=father's ID
c		ipair(i,2)=mother's ID
c		ipair(i,3)=number of offspring
c		ipair(i,4-n)= ID's of offspring
	do i=1,lss
	do j=1,M_PAIR
	ipair(i,j)=0
	end do
	end do
	max_pair=0
C	Parents and the set of offspring for every pair is found and written in
C		massiv ipair() 

	do i=ls1,ls2
	mas(i,1)=0
c	print *,(mas(i,j),j=1,5)
	end do
c	pause

	ip=0
111	ip=ip+1
	ip1=0
	ip2=0

	k=0
	do i=ls1,ls2
	if(mas(i,1).eq.0.and.mas(i,3).ne.0)then
	if (ip1.eq.0) then
	ip1=mas(i,3)
	ip2=mas(i,4)
	mas(i,1)=ip
	k=k+1
	ipair(ip,k+3)=mas(i,2)
	else
	if (mas(i,3).eq.ip1.and.mas(i,4).eq.ip2)then
	mas(i,1)=ip
	k=k+1
	ipair(ip,k+3)=mas(i,2)
	end if
	end if
	end if
	end do	
	if (k.eq.0) goto 115
	if (k.gt.max_pair)max_pair=k
	ipair(ip,1)=ip1
	ipair(ip,2)=ip2
	ipair(ip,3)=k
c	print *,ip,(ipair(ip,i),i=1,k+3)
	goto 111
115	ip=ip-1
c	pause

C	Test of declared m_pair
	if (max_pair+3.gt.M_PAIR) then
	print *,'max_pair+3>M_PAIR:',max_pair,M_PAIR
	stop
	end if

	do i=ls1,ls2
	m0=mas(i,2)
	isex=mas(i,5)
	k=0
	do j=1,ip
	if (ipair(j,isex).eq.m0)k=k+1
	end do
	nspou(i)=k
	end do

	npar=ip 
	if (npar.gt.0)print *,' initial number of nuclear families is=', npar

	return
	end


