      program relat
c	*********************************************************
c	Calculation of edge's cost on the base of mean coefficient
c	of relationship
c	Program uses modified program PEDIG

c	MAIN PROGRAM 
c	  reading of initial data files:
C		list of edges
c		list of person for relationship testing
C		pedigree data in PEDIG format
C	  testing of all massive sizes and diagnosis of errors
C	  CYCLE for each edge:
C		pedigree file reading (NO return to initial status)
C		modification of pedigree file (elimination of edge)
C		mean relationship calculation (PEDIG program)
c	************************************************************** 
      implicit none

      include "blk.incl"
      include 'mpif.h'
      integer*4 i, j, k, n,ii,jj,is,ip,im
	integer*4 ist,ijst

      integer*4 ndat,nlist,nstar,nst,ig1,ig2,ipovt
      character*128 str,sti,stc,sts,jour

      integer*4 lliste(nlistx,2),nn,nlist0,mmm,i_sex
      integer*4 mas(nt,5),liste(nlistx,2)
      integer*4 pere(nt),mere(nt),ped(2,nt),point(nt),star(nt,2)
      integer*2 sex(nt),annai(nt)
      integer*4 ord(nt),rord(nt),ndes(nt)
      real*8 statis(106),x
      real*8 f(0:nt),l(nt),d(nt)
      logical ts,ts2(2,2),chy

c     For MPI
      integer ierr, size, rank, nstar_pr
      integer status(MPI_STATUS_SIZE)
      integer nipovt, ist_m(nt), ijst_m(nt)
      real*8 statis_m(nt,3)

      include "format.incl"

c     Start MPI
      call MPI_INIT(ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, size, ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      if (rank.eq.0) then

c	READING OF FILE NAMES
	
	open (unit=1, file='task_w.inp')
      read(1,*) str !! pedigree
c      read (1,*) sti !! list
	close (unit=1)
	str='ped_ped.dat'
	sts='edge.dat'
	sti='list_new.dat'
	stc='rrr.dat'

c	READING OF LIST
      nlist=0
      open (9,file=sti,form='formatted')
   18 read (9,*,end=19) i,j
        nlist=nlist+1
        if (nlist.gt.nlistx)
     *    stop 'Increase parameter nlistx in blk.incl and recompile !'
        liste(nlist,1)=i
	liste(nlist,2)=j
        goto 18
   19   close (9)
	nlist0=nlist

c	READING OF EDGE
	nst=0
      open (unit=9,file=sts,form='formatted')
318	nst=nst+1
        read (9,*,end=319)star(nst,1),star(nst,2) !>>>
        if (nst.gt.nt)
     *    stop 'Increase parameter nt in blk.incl and recompile !'
	goto 318 !>>>>
319        close (9)
	nstar=nst-1

c	READ and test OF PEDIGREE DATA

	open (unit=9,file=str)
	n=0
418	n=n+1
        read (9,*,end=419)(mas(n,nn),nn=1,5)  
      if (mas(n,1).ne.n) then
         print 102,n,mas(n,1)
         stop
         end if
	goto 418
419	close (unit=9)
	n=n-1
	
	end if

c
      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_SEND(nlist,1,MPI_INTEGER,i,5,MPI_COMM_WORLD,ierr);
      end if
      end do

      if (rank .ne. 0) then
      call MPI_RECV(nlist, 1, MPI_INTEGER, 0, 5, MPI_COMM_WORLD,
     & status, ierr);
      end if
      

      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_SEND(nstar,1,MPI_INTEGER,i,5,MPI_COMM_WORLD,ierr);
      end if
      end do

      if (rank .ne. 0) then
      call MPI_RECV(nstar, 1, MPI_INTEGER, 0, 5, MPI_COMM_WORLD,
     & status, ierr);
      end if

      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_SEND(n,1,MPI_INTEGER,i,5,MPI_COMM_WORLD,ierr);
      end if
      end do

      if (rank .ne. 0) then
      call MPI_RECV(n, 1, MPI_INTEGER, 0, 5, MPI_COMM_WORLD,
     & status, ierr);
      end if

      do j = 1, 2
      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_SEND(liste(1,j), nlist, MPI_INTEGER, i, 5,
     & MPI_COMM_WORLD, ierr);
      end if
      end do

      if (rank .ne. 0) then
      call MPI_RECV(liste(1,j), nlist, MPI_INTEGER, 0, 5,
     & MPI_COMM_WORLD, status, ierr);
      end if
      end do

      do j = 1, 2
      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_SEND(star(1,j), nstar, MPI_INTEGER, i, 5,
     & MPI_COMM_WORLD, ierr);
      end if
      end do

      if (rank .ne. 0) then
      call MPI_RECV(star(1,j), nstar, MPI_INTEGER, 0, 5,
     & MPI_COMM_WORLD, status, ierr);
      end if
      end do

      do j = 1, 5
      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_SEND(mas(1,j), n, MPI_INTEGER, i, 5,
     & MPI_COMM_WORLD, ierr);
      end if
      end do

      if (rank .ne. 0) then
      call MPI_RECV(mas(1,j), n, MPI_INTEGER, 0, 5,
     & MPI_COMM_WORLD, status, ierr);
      end if
      end do
c 


      ist=0
      ijst=0
      nlist0=nlist

      if (n.gt.nt) then
         print 101
         stop
         end if
 
       do i=1, nlist
        if (liste(i,1).gt.n) then
          print 8512,liste(i,1)
          stop
          end if
        end do

	ndat=n !!! initial sample size

	do i=1,ndat
      pere(i)=mas(i,2)
      mere(i)=mas(i,3)
      if (pere(i).lt.0) pere(i)=0
      if (mere(i).lt.0) mere(i)=0
        if (pere(i).gt.i) then ; print 8513; stop; end if
        if (mere(i).gt.i) then ; print 8514; stop; end if
      annai(i)=mas(i,4)
      sex(i)=mas(i,5)
        end do

	do i=1,nlist
	do j=1,2
	lliste(i,j)=liste(i,j)
	end do
	END DO

      ipovt = 1


      call comp_d (n, pere, mere, ped, ord, rord, rank)

       do i=1, nlist
        ndes(ord(lliste(i,1)))=1
       end do

      do i=1,n
        point(i)=0
        l(i)=0.
        d(i)=0.
        end do
      call meuw(n, ped, f, d, l, point,ndes,rank)


      n=n + 1
      do i=1, n
        point(i)=0
        l(i)=0.
      end do


      do i=1, 106
      statis(i)=0.d0
      end do


        do i=1,nlist
          do j=i+1, nlist
	    if (lliste(i,2).ne.lliste(j,2))goto 665
           ip=ord(lliste(i,1))
           im=ord(lliste(j,1))
           ped(1,n)=ip
           ped(2,n)=im
           call consang(n,ped,f,d,l,point,rank)

           call statt(f(n),statis,1,ist,ijst,rank)

665	continue
           end do
         end do
        call statt(x,statis,2,ist,ijst,rank)

      nipovt = (nstar / size) + 1
      nstar_pr = nipovt * (rank+1) + 1
      ipovt = nipovt * rank
      if (rank.eq.0) ipovt = 0


250	ipovt=ipovt+1
      
C	PEDIGREE MODIFICATION	
	ist=star(ipovt,1)
	ijst=star(ipovt,2)	
        
	i_sex=mas(ist,5) !!! star sex

      pere(1)=0
      mere(1)=0
      annai(1)=22
      sex(1)=i_sex
	lliste(1,1)=1
	k=0
	do i=1,nlist
	if (ist.eq.liste(i,1))then
	k=1
	lliste(1,2)=liste(i,2)
	end if
	end do

	do i=1,ndat
	if (mas(i,i_sex+1).ne.ist) goto 518
	if (mas(i,4-i_sex).ne.ijst) goto 518
	
519	if (i_sex.eq.1)then
	pere(i+1)=1 !>>>
	mere(i+1)=mas(i,3)+1
	goto 29
	else
	pere(i+1)=mas(i,2)+1
	mere(i+1)=1 !>>>
	goto 29
	end if
518     mmm=1
	if (mas(i,2).eq.0)mmm=0
	  pere(i+1)=mas(i,2)+mmm
      mere(i+1)=mas(i,3)+mmm
29      annai(i+1)=mas(i,4)
      sex(i+1)=mas(i,5)
	end do
	n=ndat+1
	do i=1,nlist0
	lliste(i+k,1)=liste(i,1)+1
	lliste(i+k,2)=liste(i,2)
	end do
	nlist=nlist0+k


c *** WEIGHT CALCULATION with the help of modified program PEDIG
220      call comp_d (n, pere, mere, ped, ord, rord, rank)

       do i=1, nlist
        ndes(ord(lliste(i,1)))=1
       end do

      do i=1,n
        point(i)=0
        l(i)=0.
        d(i)=0.
        end do
      call meuw(n, ped, f, d, l, point,ndes,rank)


      n=n + 1
      do i=1, n
        point(i)=0
        l(i)=0.
        end do

        do i=1, 106
          statis(i)=0.d0
          end do


        do i=1,nlist
          do j=i+1, nlist
	    if (lliste(i,2).ne.lliste(j,2))goto 666		
           ip=ord(lliste(i,1))
           im=ord(lliste(j,1))
           ped(1,n)=ip
           ped(2,n)=im
           call consang(n,ped,f,d,l,point,rank)

           call statt(f(n),statis,1,ist,ijst,rank)

666	continue
           end do
         end do
        call statt(x,statis,2,ist,ijst,rank)
      ist_m(ipovt) = ist
      ijst_m(ipovt) = ijst
      do is = 1, 3
      statis_m(ipovt, is) = statis(is+2)
      end do
      print *, rank, ': ', ipovt, ist_m(ipovt), ijst_m(ipovt),
     & (statis_m(ipovt, is), is = 1, 3)
	if (nstar.eq.0) goto 251
	if ((ipovt.lt.nstar_pr).and.(ipovt.lt.nstar)) goto 250
251   continue

      if (rank .ne. 0) then
      call MPI_SEND(ist_m(nipovt*rank+1), nipovt,
     & MPI_INTEGER, 0, 5, MPI_COMM_WORLD, ierr);
      end if

      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_RECV(ist_m(nipovt*i+1), nipovt,
     & MPI_INTEGER, i, 5, MPI_COMM_WORLD, status, ierr);
      end if
      end do

      if (rank .ne. 0) then
      call MPI_SEND(ijst_m(nipovt*rank+1), nipovt,
     & MPI_INTEGER, 0, 5, MPI_COMM_WORLD, ierr);
      end if

      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_RECV(ijst_m(nipovt*i+1), nipovt,
     & MPI_INTEGER, i, 5, MPI_COMM_WORLD, status, ierr);
      end if
      end do

      do j = 1, 3
      if (rank .ne. 0) then
      call MPI_SEND(statis_m(nipovt*rank+1,j), nipovt,
     & MPI_DOUBLE_PRECISION, 0, 5, MPI_COMM_WORLD, ierr);
      end if

      do i = 1, size-1
      if (rank .eq. 0) then
      call MPI_RECV(statis_m(nipovt*i+1,j), nipovt,
     & MPI_DOUBLE_PRECISION, i, 5, MPI_COMM_WORLD, status, ierr);
      end if
      end do
      end do

      if (rank .eq. 0) then
      open(unit=3, file=stc) !!!OPEN OUTPUT FILE
      do i = 1, nstar
      write(3,6667) ist_m(i), ijst_m(i), (statis_m(i,is), is = 1, 3)
      end do
      close(3)
      end if

      call MPI_FINALIZE(ierr)


      stop
      end



      subroutine statt(x,statis,io,ist,ijst,rank)
      implicit none
      include 'mpif.h'
      integer ierr, size, rank
      integer status(MPI_STATUS_SIZE) 
      integer*4 ist,ijst
      integer*4 io, nm,i,ii,j,jj,k,l
      real*8  statis(*),x
      character*1 etoile

      include "format.incl"

      if (io.eq.0) then
        do i=1, 106
          statis(i)=0.d0
          end do
        return

      else if (io.eq.1) then
        statis(3)=statis(3) + 1.d0
        statis(4)=statis(4) + x
        statis(5)=statis(5) +x*x
        return

      else if (io.eq.2) then
        etoile='*'
        if (statis(3).gt.0.d0) then
          statis(4)=statis(4)/statis(3)
          statis(5)=statis(5) - statis(3)*statis(4)*statis(4)
          statis(5)=dsqrt(statis(5)/statis(3))
          end if
	end if
      return
      end

      subroutine comp_d (n,sire, dam,ped,ord,rord, rank)
      implicit none
      include 'mpif.h'
      integer ierr, size, rank
      integer status(MPI_STATUS_SIZE) 
      integer*4 n,sire(*),dam(*),ped(2,*),nbit,k,i,j,ks,kd
      integer*4 ord(*), rord(*)

      include "format.incl"

	nbit=0
	do i=1, n
	  ord(i)=0
	  end do
	k=0
	do while (k.lt.n .and. nbit.le.20)
	  nbit=nbit + 1
	  do i=1, n
	    if (ord(i).eq.0) then
		if (sire(i).le.0 .or. ord(sire(i)).ne.0) then
	   	 if (dam(i) .le.0 .or. ord( dam(i)).ne.0) then
		  k=k+1
		  ord(i)=k
                rord(k)=i
	         end if
	        end if
	    end if
	  end do
c        print *,nbit,k,n
	end do

c  Test qu'il n'y a pas de boucle dans le pedigree
      j=0
      if (k.ne.n) then
        do i=1,n
          if (ord(i).eq.0) then
            j=j+1
            if (j.lt.100) print '(3i10)',i,sire(i),dam(i)
            sire(i)=0
            dam(i)=0
            k=k+1
            ord(i)=k
            rord(k)=i
          end if
       end do
      end if
      if (j.gt.0) print 900,j

      do i=1, n
	  j=rord(i)
	  ped(1,i)=sire(j)
	  ped(2,i)=dam(j)
	  if (ped(1,i).gt.0) ped(1,i)=ord(sire(j))
	  if (ped(2,i).gt.0) ped(2,i)=ord(dam(j))
        end do

      DO i=1,n
        if (i.le.ped(1,i) .or. i.le.ped(2,i)) then
	    print *,'Problem in coding pedigree'
          print *,i, ped(1,i),ped(2,i)
          stop
          end if
        ks=ped(1,i)
        kd=ped(2,i)
        ped(1,i)=max(ks,kd)
        ped(2,i)=min(ks,kd)
        end do
	return
	end


C*** Methode de Meuwissen
      subroutine meuw(n, ped, f, d, l ,point,ndes,rank)
      implicit none
       include 'mpif.h'
       integer ierr, size, rank
       integer status(MPI_STATUS_SIZE) 
	integer*4 n, ped(2,*), point(*),ndes(*),np,npar
	integer*4 ninbr, i, j,k, ik, is, id, ks, kd
	real*8 f(0:n), d(*), l(*),r, fi


      ninbr=0
      f(0)=-1.d0
      DO i=1,n
        point(i)=0
        end do
      DO i=1,n
        if (ped(1,i).gt.0) ndes(ped(1,i))=ndes(ped(1,i))+1
        if (ped(2,i).gt.0) ndes(ped(2,i))=ndes(ped(2,i))+1
        end do
      npar=0
      do i=1, n
        if (ndes(i).gt.0) npar=npar+1
        end do
      if (npar.eq.0) return

      DO i=1,n
       if (ndes(i).gt.0) then
        is=ped(1,i)
        id=ped(2,i)
        ped(1,i)=max(is,id)
        ped(2,i)=min(is,id)
        d(i)=.5d0 - .25d0*(f(is)+f(id))
        if (is.eq.0.or.id.eq.0) then
           f(i)=0.d0
        else
          np=0
          fi=-1.d0
          l(i)=1.d0
          j=i
          do while(j.ne.0)
            k=j
            r=.5d0 * l(k)
            ks=ped(1,k)
            kd=ped(2,k)
            if (ks.gt.0) then
              l(ks)=l(ks) + r
              do while(point(k).gt.ks)
                k=point(k)
                end do
              if (ks.ne.point(k)) then
                point(ks)=point(k)
                point(k)=ks
                end if
              if (kd.gt.0) then
                l(kd)=l(kd) + r
                do while(point(k).gt.kd)
                  k=point(k)
                  end do
                if (kd.ne.point(k)) then
                  point(kd)=point(k)
                  point(k)=kd
                  end if
                end if
              end if
              fi=fi + l(j)*l(j)*d(j)
              l(j)=0.d0
              k=j
              j=point(j)
              point(k)=0
              np=np+1
              end do
            f(i)=fi
            if (fi.gt.0.000001d0) ninbr=ninbr + 1
            end if
           end if
          end do


       RETURN
       END

C*** Methode de Meuwissen
      subroutine consang(i, ped, f, d, l ,point,rank)
      implicit none
       include 'mpif.h'
       integer ierr, size, rank
       integer status(MPI_STATUS_SIZE)
	integer*4 ped(2,*), point(*)
	integer*4 i, j,k, ik, is, id, ks, kd
	real*8 f(0:i), d(*), l(*),r, fi

        is=ped(1,i)
        id=ped(2,i)
        ped(1,i)=max(is,id)
        ped(2,i)=min(is,id)
        d(i)=.5d0 - .25d0*(f(is)+f(id))
        if (is.eq.0.or.id.eq.0) then
           f(i)=0.d0
           return
           end if
        fi=-1.d0
        l(i)=1.d0
        j=i
        do while(j.ne.0)
          k=j
          r=.5d0 * l(k)
          ks=ped(1,k)
          kd=ped(2,k)
          if (ks.gt.0) then
            l(ks)=l(ks) + r
            do while(point(k).gt.ks)
              k=point(k)
              end do
            if (ks.ne.point(k)) then
              point(ks)=point(k)
              point(k)=ks
              end if
            if (kd.gt.0) then
              l(kd)=l(kd) + r
              do while(point(k).gt.kd)
                k=point(k)
                end do
              if (kd.ne.point(k)) then
                point(kd)=point(k)
                point(k)=kd
                end if
              end if
            end if
          fi=fi + l(j)*l(j)*d(j)
          l(j)=0.d0
          k=j
          j=point(j)
          point(k)=0
          end do
        f(i)=fi

       RETURN
       END
